<?php

namespace HCM\FPA\Repository;

use Doctrine\ORM\EntityManager;
use HCM\Util\Util;

class RelatCustomDirfRepository {

    protected  $connection;
    public function __construct(EntityManager $entityManager) {
        $this->entityManager = $entityManager;
    }
    
    public function arrayToList($array, $espacador) {
        $lista = array_map(function($val){return $val;}, $array);
        return implode($espacador, $lista);
    }
    
    /**
     * @return array
     */

    public function getRelatCustomDirf($parameters, $filters) {
        //Montagem dos parâmetros
        $params = array(
            "P_COMPETENCIA"    => $parameters['P_DTMESCOMPETENC'],
            "P_NRORG"          => $parameters['P_NRORG'],
            "P_NRCENARIO"      => $parameters['NRTPMODALIDCAL'],
            "P_NRGRPDIRF"      => $parameters['NRGRPDIRF'], // 10
            "P_NRVINCULOM"     => null,
            "P_NRPESSOA"       => null,
            "P_NRESTRUTLEGAL"  => null,
            "P_NRESTRUTGEREN"  => null,
            "P_MES"            => null,
            "P_IDDADOSVINC"    => 'N'
        );
        
        if(array_key_exists('NRVINCULOM', $parameters))
            $params["P_NRVINCULOM"] = $parameters["NRVINCULOM"];
        
        if(array_key_exists('NRPESSOA', $parameters))
            $params["P_NRPESSOA"] = $parameters["NRPESSOA"];
        
        if(array_key_exists('NRESTRUTLEGAL', $parameters))
            $params["P_NRESTRUTLEGAL"] = $this->arrayToList($parameters['NRESTRUTLEGAL'], ',');
        
        if(array_key_exists('NRESTRUTGEREN', $parameters))
            $params["P_NRESTRUTGEREN"] = $this->arrayToList($parameters['NRESTRUTGEREN'], ',');
        
        if(array_key_exists('NREVENTOM', $parameters))
            $params["P_NREVENTOM"] = $this->arrayToList($parameters['NREVENTOM'], ',');
        
        if(array_key_exists('IDDADOSVINC', $parameters))
            $params["P_IDDADOSVINC"] = $parameters['IDDADOSVINC'];
        
        if(array_key_exists('MES', $parameters))
            $params["P_MES"] = '%'.$parameters['MES'].'%';

        //Montagem das query part's do tipo de regime de apuração
        $regime = $parameters['NRREGIMEAPUR']; //todo 
        
        //Regime Competência
        $qryPart[1][0] = "/*Regime Competência 0*/";
        $qryPart[1][1] = "/*Regime Competência 1*/";
        $qryPart[1][2] = "/*Regime Competência 2*/";
        $qryPart[1][3] = "/*Regime Competência 3*/";
        $qryPart[1][4] = "/*Regime Competência 4*/";
        $qryPart[1][5] = "/*Regime Competência 5*/";
        $qryPart[1][6] = "/*Regime Competência 6*/
            AND LANC.DTOCORRENCIACALC BETWEEN DECODE(LANC.NRTIPOMOVIMENT, 2, ADD_MONTHS(TRUNC(TO_DATE(:P_COMPETENCIA,'DD/MM/YYYY'),'YEAR'),-1),
                                                                          4, TO_DATE(:P_COMPETENCIA,'DD/MM/YYYY'),
                                                                             TRUNC(TO_DATE(:P_COMPETENCIA,'DD/MM/YYYY'),'YEAR'))
                                          AND TO_DATE(:P_COMPETENCIA,'DD/MM/YYYY')";
        $qryPart[1][7] = "/*Regime Competência 7*/
            AND LANC.DTOCORRENCIACALC BETWEEN TRUNC( TO_DATE( :P_COMPETENCIA ), 'YEAR' ) AND :P_COMPETENCIA";
        $qryPart[1][8] = "/*Regime Competência 8*/
          WHEN GIT.NMITEM = 'RTPO' AND LANC.NREVENTOM IN (1140,1145) THEN TO_CHAR(LANC.DTOCORRENCIA, 'yyyymm')";
        
        //Regime Caixa
        $qryPart[2][0] = "/*RegimeCaixa 0*/
          WHEN GIT.NMITEM = 'RTRT' AND LANC.DTOCORRENCIARESC IS NOT NULL THEN TO_CHAR(LANC.DTOCORRENCIARESC, 'yyyymm')";
        $qryPart[2][1] = "/*RegimeCaixa 1*/
          WHEN LANC.NREVENTOM = 1390 THEN TO_CHAR(LANC.DTOCORRENCIACALC, 'MM/YYYY')
          WHEN LANC.NRTIPOMOVIMENT = 1 AND (LANC.DTRESCISAOVINC IS NULL OR TO_CHAR(LANC.DTOCORRENCIACALC,'MMYYYY') <> TO_CHAR(LANC.DTRESCISAOVINC,'MMYYYY')) THEN TO_CHAR(ADD_MONTHS(LANC.DTOCORRENCIACALC, 1),'MM/') || SUBSTR(TO_DATE(:P_COMPETENCIA,'DD/MM/YYYY'), 7, 4)";
        $qryPart[2][2] = "/*RegimeCaixa 2*/
          WHEN GIT.NMITEM = 'RTRT-ADIANT-CX' THEN TO_CHAR(LANC.DTOCORRENCIA, 'MM/YYYY')
          WHEN GIT.NMITEM = 'RTRT-ADIANT-CX-ANT' THEN TO_CHAR(ADD_MONTHS(LANC.DTOCORRENCIA, 1), 'MM/YYYY')";
        $qryPart[2][3] = "/*RegimeCaixa 3*/
          WHEN GIT.NMITEM IN ('RTRT-ADIANT-CX') /*Subtrai o adiantamento do mês para entrar no mês anterior*/
          THEN DECODE(IEV.IDINCIDEVENTO, 'N', 0, DECODE(IEV.IDINCIDEVENTO, '-', -1 * LANC.VREVENTOFOLHA, LANC.VREVENTOFOLHA)) * (-1)";
        $qryPart[2][4] = "/*RegimeCaixa 4*/
            UNION ALL
              SELECT GIT.NRORG, GIT.NRITEM, 'RTRT-ADIANT-CX-ANT' AS NMITEM, GIT.NRGRPINCIDE, GIT.NRTIPOINCIDE, GIT.DSITEM
              FROM FPA_GRPITEM GIT
              WHERE (GIT.NRORG = :P_NRORG OR GIT.NRORG = 0)
                AND GIT.NRGRPINCIDE = :P_NRGRPDIRF
                 AND GIT.NMITEM = 'RTRT-ADIANT-CX'";
        $qryPart[2][5] = "/*RegimeCaixa 5*/
             OR LANC.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTRT-ADIANT-CX', 10)
             OR LANC.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTRT-ADIANT-CX-ANT', 10)";
        $qryPart[2][6] = "/*RegimeCaixa 6*/
            AND LANC.DTOCORRENCIACALC BETWEEN DECODE(LANC.NRTIPOMOVIMENT,  2, ADD_MONTHS(TRUNC(TO_DATE(:P_COMPETENCIA,'DD/MM/YYYY'),'YEAR'), -1),
                                                                      10, ADD_MONTHS(TRUNC(TO_DATE(:P_COMPETENCIA,'DD/MM/YYYY'),'YEAR'), -1),
                                                                       1, ADD_MONTHS(TRUNC(TO_DATE(:P_COMPETENCIA,'DD/MM/YYYY'),'YEAR'), -1),
                                                                       4, TO_DATE(:P_COMPETENCIA,'DD/MM/YYYY'),
                                                                       TRUNC(TO_DATE(:P_COMPETENCIA,'DD/MM/YYYY'),'YEAR'))
            AND DECODE(LANC.NRTIPOMOVIMENT, 1, DECODE(TO_CHAR(LANC.DTRESCISAOVINC, 'MMYYYY'), TO_CHAR(LANC.DTOCORRENCIACALC,'MMYYYY'), TO_DATE(:P_COMPETENCIA,'DD/MM/YYYY'), ADD_MONTHS(TO_DATE(:P_COMPETENCIA,'DD/MM/YYYY'), -1)), TO_DATE(:P_COMPETENCIA,'DD/MM/YYYY'))";
        $qryPart[2][7] = "/*RegimeCaixa 7*/
            AND LANC.DTOCORRENCIACALC BETWEEN ADD_MONTHS(TRUNC(TO_DATE( :P_COMPETENCIA ), 'YEAR'), -1) AND ADD_MONTHS( :P_COMPETENCIA, -1)";
        $qryPart[2][8] = "/*RegimeCaixa 8*/
          WHEN GIT.NMITEM = 'RTPO' AND LANC.NREVENTOM IN (1140,1145) THEN TO_CHAR(ADD_MONTHS(LANC.DTOCORRENCIA,1), 'yyyymm')";
        
        //Query principal
        $sql = "
SELECT
  RES.NRORG,
  RES.NRESTRUTLEGAL,
  RES.NMESTRUTLEGAL,
  RES.NRESTRUTGEREN,
  RES.NMESTRUTGEREN,
  RES.NRVINCULOM,
  RES.NRPESSOA,
  RES.NRCPFPESSOA,
  RES.NMPESSOA,
  RES.CDRECEITA,
  RES.MES,
  RES.NMITEM,
  RES.DSITEM,
  RES.NRTIPOINCIDE,
  RES.NMTIPOINCIDE,
  RES.NRTIPOMOVIMENT,
  RES.NMTIPOMOVIMENT,
  RES.NREVENTOM,
  SUM(RES.VREVENTOFOLHA) VREVENTOFOLHA
FROM (SELECT
        /*Comum*/
        LANC.NRORG,
        LANC.NRESTRUTLEGAL,
        EML.NMESTRUTURAM NMESTRUTLEGAL,
        LANC.NRESTRUTGEREN,
        EMG.NMESTRUTURAM NMESTRUTGEREN,
        DECODE(:P_IDDADOSVINC, 'S', LANC.NRVINCULOM, NULL) NRVINCULOM,
        LANC.NMVINCULOM,
        DECODE(:P_IDDADOSVINC, 'S', PH.NRPESSOA, NULL) NRPESSOA,
        DECODE(:P_IDDADOSVINC, 'S', PH.NRCPFPESSOA, NULL) NRCPFPESSOA,
        DECODE(:P_IDDADOSVINC, 'S', PH.NMPESSOA, NULL) NMPESSOA,
        /**/
        GIT.NRITEM,
        GIT.NMITEM,
        GIT.DSITEM,
        IEV.NRTIPOINCIDE,
        TPI.NMTIPOINCIDE,
        DECODE(:P_IDDADOSVINC, 'S', LANC.NRTIPOMOVIMENT, NULL) NRTIPOMOVIMENT,
        DECODE(:P_IDDADOSVINC, 'S', TPM.NMTIPOMOVIMENT, NULL) NMTIPOMOVIMENT,
        DECODE(:P_IDDADOSVINC, 'S', LANC.NREVENTOM, NULL) NREVENTOM,
        EH.NMEVENTOH,
        /**/
        CASE
          WHEN LANC.NREVENTOM = 870 THEN '3562'
          ELSE LPAD(VE.CODRECEITA, 4, '0')
        END CDRECEITA,
        CASE
          ".$qryPart[$regime][0]."
          WHEN INSTR(GIT.NMITEM, '-13S') > 0 THEN '13/'||TO_CHAR(TO_DATE(:P_COMPETENCIA,'DD/MM/YYYY'), 'YYYY') /*Verifica se o item é do 13º salário (Ex.: se o id13Sal for '-13S' então 'RTRT-13S' é o M13 do 'RTRT')*/
          ".$qryPart[$regime][1]."
          --WHEN GIT.NMITEM = 'RTPO' AND LANC.NREVENTOM IN (1140,1145) AND TO_CHAR(LANC.DTOCORRENCIA, 'YYYY') = TO_CHAR(LANC.DTOCORRENCIACALC, 'YYYY') THEN TO_CHAR(LANC.DTOCORRENCIA, 'MM/YYYY')
          --WHEN GIT.NMITEM = 'RTPO' AND LANC.NREVENTOM IN (1140,1145) AND TO_CHAR(LANC.DTOCORRENCIA, 'YYYY') <> TO_CHAR(LANC.DTOCORRENCIACALC, 'YYYY') THEN TO_CHAR(LANC.DTOCORRENCIA, 'MM/YYYY') /*férias partidas que terminam no ano seguinte*/
          WHEN GIT.NMITEM = 'RTPO-FERIAS' AND LANC.NREVENTOM IN (1140) THEN TO_CHAR(LANC.DTOCORRENCIACALC, 'MM/YYYY')
          WHEN GIT.NMITEM = 'RTPO-FERIAS' AND LANC.NREVENTOM IN (1145) THEN TO_CHAR(LANC.DTOCORRENCIACALC, 'MM/YYYY')
          ".$qryPart[$regime][8]."
          ".$qryPart[$regime][2]."
          ELSE TO_CHAR(LANC.DTOCORRENCIACALC, 'YYYYMM')
        END MES, /*são as colunas do pivô*/
        CASE
          WHEN GIT.NMITEM IN ('RTRT-13S','RTPO-13S') /*Zera itens do 13º na rescisao caso não possua data de rescisão*/
          AND LANC.DTRESCISAOVINC IS NULL AND IEV.NREVENTOM IN (600,1180)
          THEN 0
          WHEN GIT.NMITEM IN ('RTRT-13S','RTPO-13S') /*Zera itens do 13º caso possua data de rescisão*/
          AND LANC.DTRESCISAOVINC IS NOT NULL AND LANC.DTRESCISAOVINC <= (TO_DATE(:P_COMPETENCIA,'DD/MM/YYYY')+19) AND IEV.NREVENTOM IN (110,125,1150)
          THEN 0
          /*WHEN GIT.NMITEM = 'RTPO' /*Zera o RTPO caso o RTRT for zero, pois não há IR, então não há deduções para cálculo de IR*
          AND (SELECT  SUM(DECODE(IE.IDINCIDEVENTO, 'N', 0, DECODE(IE.IDINCIDEVENTO, '-', -1 * IC.VREVENTOFOLHA, IC.VREVENTOFOLHA)))
                 FROM FPA_ITECALCFOLHA IC
                 JOIN FPA_INCIDEVENTO IE ON (IE.NRORG = 0 OR IE.NRORG = IC.NRORG)
                                        AND IE.NREVENTOM = IC.NREVENTOM
                                        AND IE.NRTIPOINCIDE = 73 /*RTRT*
                WHERE IC.NRORG = LANC.NRORG
                  AND IC.NRCALCULOFOLHA = LANC.NRCALCULOFOLHA
                  AND IC.NRVINCULOM = LANC.NRVINCULOM) = 0
          THEN 0*/
          WHEN GIT.NMITEM IN ('RTRT-ESTAG') /*Zera itens de estagiário quando o tipo de vínculo não for estagiário*/
          AND LANC.NRTIPOVINCULOM <> 2 /*Estagiário*/
          THEN 0
          ".$qryPart[$regime][3]."
          ELSE DECODE(IEV.IDINCIDEVENTO, 'N', 0, DECODE(IEV.IDINCIDEVENTO, '-', -1 * LANC.VREVENTOFOLHA, LANC.VREVENTOFOLHA)) /*Considera o '+' e '-' no sum*/
        END VREVENTOFOLHA
      FROM (SELECT 
              VM.NRORG, VM.NRVINCULOM, VM.NRPESSOA, VM.DTADMISSAOVINC, VM.DTRESCISAOVINC, VM.NRTIPOVINCULOM, VM.NRVINCULOEMPREG, VM.NMVINCULOM,
              VH.DTMESCOMPETENC, VH.NRESTRUTLEGAL, VH.NRESTRUTGEREN, VH.NRESTRUTSIND,
              CF.NRCALCULOFOLHA, CF.NRTIPOMOVIMENT, CF.NRTPMODALIDCAL, CF.NROCORRECAL, CF.DTOCORRENCIA AS DTOCORRENCIACALC,
              ICF.NRITEMCALCFOLHA, ICF.NREVENTOM, ICF.VRREFFOLHA, ICF.VREVENTOFOLHA, ICF.IDREFEVALORCALC, ICF.DTOCORRENCIA,
              CASE WHEN CF.DTOCORRENCIA = TRUNC(VM.DTRESCISAOVINC,'MONTH')
                   THEN (SELECT RESC.DTOCORRENCIA
                           FROM FPA_CALCULOFOLHA CFR
                           JOIN FPA_ITECALCFOLHA RESC ON RESC.NRORG = CFR.NRORG
                                                     AND RESC.NRCALCULOFOLHA = CFR.NRCALCULOFOLHA
                                                     AND RESC.NRVINCULOM = VM.NRVINCULOM
                                                     AND RESC.NREVENTOM = 3050
                          WHERE CFR.NRORG = VM.NRORG
                            AND CFR.NRTIPOMOVIMENT = 1
                            AND CFR.DTOCORRENCIA = TRUNC(VM.DTRESCISAOVINC,'MONTH')
                            AND CFR.NRTPMODALIDCAL = CF.NRTPMODALIDCAL
                            AND CFR.NROCORRECAL = 1)
                   ELSE NULL
              END AS DTOCORRENCIARESC
           FROM FPA_CALCULOFOLHA CF 
           JOIN DATA DT ON DT.DTDATA = CF.DTOCORRENCIA
           JOIN FPA_ITECALCFOLHA ICF ON ICF.NRORG          = CF.NRORG
                                    AND ICF.NRCALCULOFOLHA = CF.NRCALCULOFOLHA
           JOIN GPE_VINCULOM VM ON VM.NRORG      = ICF.NRORG
                               AND VM.NRVINCULOM = ICF.NRVINCULOM
                               AND ( VM.NRVINCULOM = :P_NRVINCULOM OR :P_NRVINCULOM IS NULL )
                               AND ( VM.NRPESSOA   = :P_NRPESSOA   OR :P_NRPESSOA   IS NULL )
           JOIN GPE_VINCULOH VH ON VH.NRORG          = VM.NRORG
                               AND VH.NRVINCULOM     = VM.NRVINCULOM
                               AND ( INSTR(','||:P_NRESTRUTLEGAL||',', ','||VH.NRESTRUTLEGAL||',' ) > 0 OR :P_NRESTRUTLEGAL IS NULL )
                               AND ( INSTR(','||:P_NRESTRUTGEREN||',', ','||VH.NRESTRUTGEREN||',' ) > 0 OR :P_NRESTRUTGEREN IS NULL )
                               AND VH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM (SELECT H1.DTMESCOMPETENC FROM GPE_VINCULOH H1
                                                        WHERE H1.NRORG      = VH.NRORG
                                                        AND H1.NRVINCULOM = VH.NRVINCULOM
                                                        AND H1.DTMESCOMPETENC <= DT.DTDATA ORDER BY H1.DTMESCOMPETENC DESC) WHERE ROWNUM = 1)
           WHERE CF.NRORG = :P_NRORG
             AND CF.DTOCORRENCIA BETWEEN ADD_MONTHS(TRUNC(TO_DATE(:P_COMPETENCIA,'DD/MM/YYYY'),'YEAR'),-1) AND TO_DATE(:P_COMPETENCIA,'DD/MM/YYYY')
             AND CF.NRTPMODALIDCAL = :P_NRCENARIO /*Cenário real apenas*/
          ) LANC
      
      /*Estrutura Legal*/
      LEFT JOIN ESTRUTURAM EML ON EML.NRORG        = LANC.NRORG
                              AND EML.NRESTRUTURAM = LANC.NRESTRUTLEGAL
      /*Estrutura Gerencial*/
      LEFT JOIN ESTRUTURAM EMG ON EMG.NRORG        = LANC.NRORG
                              AND EMG.NRESTRUTURAM = LANC.NRESTRUTGEREN
      
      /*Evento*/
      JOIN FPA_EVENTOH EH ON EH.NREVENTOM      = LANC.NREVENTOM
                         AND EH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM FPA_EVENTOH E 
                                                  WHERE E.NRORG           = EH.NRORG
                                                    AND E.NREVENTOM       = EH.NREVENTOM
                                                    AND E.DTMESCOMPETENC <= TO_DATE(:P_COMPETENCIA,'DD/MM/YYYY'))
      /*Movimento*/
      JOIN FPA_TIPOMOVIMENT TPM ON ( TPM.NRORG = LANC.NRORG OR TPM.NRORG = 0 )
                               AND TPM.NRTIPOMOVIMENT = LANC.NRTIPOMOVIMENT
      
      /*Código da receita do vínculo em questão (item 3.5)*/
      LEFT JOIN GPE_VINCULOEMPREG VE ON VE.NRVINCULOEMPREG = LANC.NRVINCULOEMPREG
      
      /*CPF e Nome do vínculo em questão (item 3.6)*/
      JOIN GPE_PESSOA  PE ON PE.NRORG    = LANC.NRORG
                         AND PE.NRPESSOA = LANC.NRPESSOA
      JOIN GPE_PESSOAH PH ON PH.NRORG    = LANC.NRORG
                         AND PH.NRPESSOA = PE.NRPESSOA
                         AND PH.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM GPE_PESSOAH
                                                   WHERE DTMESCOMPETENC <= TO_DATE(:P_COMPETENCIA,'DD/MM/YYYY')
                                                     AND NRORG    = LANC.NRORG
                                                     AND NRPESSOA = PE.NRPESSOA )
      /*Grupo de incidência da DIRF, Itens de Grupo e suas Incidências de eventos e os Itens de Cálculo*/
      JOIN (  SELECT GIT.NRORG, GIT.NRITEM, GIT.NMITEM, GIT.NRGRPINCIDE, GIT.NRTIPOINCIDE, GIT.DSITEM
              FROM FPA_GRPITEM GIT
              WHERE (GIT.NRORG = :P_NRORG OR GIT.NRORG = 0)
                AND GIT.NRGRPINCIDE  = :P_NRGRPDIRF
            ".$qryPart[$regime][4]."
            ) GIT ON ( GIT.NRORG = LANC.NRORG OR GIT.NRORG = 0 )
                 AND GIT.NRGRPINCIDE = :P_NRGRPDIRF
                 
      JOIN FPA_INCIDEVENTO IEV ON ( IEV.NRORG = LANC.NRORG OR IEV.NRORG = 0 )
                              AND IEV.NRTIPOINCIDE = GIT.NRTIPOINCIDE
                              AND IEV.NREVENTOM    = LANC.NREVENTOM
      
      JOIN FPA_TIPOINCIDE  TPI ON TPI.NRTIPOINCIDE = IEV.NRTIPOINCIDE
      WHERE LANC.NRORG = :P_NRORG
        AND ( LANC.DTRESCISAOVINC IS NULL OR ( LANC.DTRESCISAOVINC >= TRUNC( TO_DATE(:P_COMPETENCIA,'DD/MM/YYYY'), 'YEAR' ) ) )
        AND (   LANC.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RIAP', 2)
             OR LANC.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RIAP-DIFF', 1)
             OR LANC.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTRT', 19)
             OR LANC.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTRT', 1)
             OR LANC.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTRT-FERIAS', 2)
             OR LANC.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTRT-ESTAG', 1)
             OR LANC.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTPO', 1)
             OR LANC.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTPO', 2)
             OR LANC.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTPO-FERIAS', 2)
             OR LANC.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTDP', 1)
             OR LANC.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTDP', 2)
             OR LANC.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTDP-13S', 4)
             OR LANC.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTPA', 1)
             OR LANC.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RIIRP', 1)
             OR LANC.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTRT-13S', 8)
             OR LANC.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTRT-13S', 1)
             OR LANC.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTRT-13S', 4)
             OR LANC.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTRT-13S-INF', 8)
             OR LANC.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTRT-13S-INF', 1)
             OR LANC.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTRT-13S-INF', 4)
             OR LANC.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTPO-13S', 8)
             OR LANC.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTPO-13S', 1)
             OR LANC.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTPO-13S', 4)
             OR LANC.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTPA-13S', 8)
             OR LANC.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTPA-13S', 4)
             OR LANC.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTIRF-13S', 8)
             OR LANC.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTIRF-13S', 1)
             OR LANC.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTIRF-13S', 4)
             OR LANC.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTIRF', 1)
             OR LANC.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTIRF', 10)
             OR LANC.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTIRF', 2)
             OR LANC.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RIDAC', 1)
             OR LANC.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RIIRP', 1)
             OR LANC.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RIO', 1)
             ".$qryPart[$regime][5]."
             )
        ".$qryPart[$regime][6]."
        
        AND LANC.NREVENTOM = DECODE(LANC.NRTIPOMOVIMENT, 10, DECODE(LANC.NREVENTOM, 475, 475, DECODE(LANC.DTOCORRENCIACALC, TO_DATE(:P_COMPETENCIA,'DD/MM/YYYY'), 1390, 0)), LANC.NREVENTOM)
        AND LANC.NREVENTOM = DECODE(LANC.NRTIPOMOVIMENT,  1, DECODE(LANC.NREVENTOM, 205239, 0, 205543, 0, LANC.NREVENTOM), LANC.NREVENTOM) /*Apenas devem vir no movimento 4 (13º sal)*/
        AND GIT.NRITEM != 99 /*Todos os itens, exceto o 'informações complementares'*/
        AND EXISTS ( SELECT 1 FROM FPA_ITECALCFOLHA
                      WHERE NRORG = LANC.NRORG
                        AND NRCALCULOFOLHA = LANC.NRCALCULOFOLHA
                        AND NRVINCULOM = LANC.NRVINCULOM
                        AND NREVENTOM IN (SELECT NREVENTOM FROM FPA_INCIDEVENTO WHERE (NRORG = LANC.NRORG OR NRORG = 0) AND NRTIPOINCIDE = 109)
                        AND VREVENTOFOLHA > 0 )
) RES
WHERE (RES.MES LIKE :P_MES OR :P_MES IS NULL )
GROUP BY RES.NRORG, RES.NRESTRUTLEGAL, RES.NMESTRUTLEGAL, RES.NRESTRUTGEREN, RES.NMESTRUTGEREN, RES.NRVINCULOM,
  RES.NRPESSOA, RES.NRCPFPESSOA, RES.NMPESSOA, RES.CDRECEITA, RES.MES, RES.NMITEM, RES.DSITEM, RES.NRTIPOINCIDE,
  RES.NMTIPOINCIDE, RES.NRTIPOMOVIMENT, RES.NMTIPOMOVIMENT, RES.NREVENTOM
ORDER BY RES.NMESTRUTLEGAL, RES.CDRECEITA, RES.NRCPFPESSOA, RES.MES, RES.NMITEM/*, RES.NREVENTOM*/
        ";
        
        $query = $this->entityManager->getConnection()->prepare($sql);
        
        $query->execute($params);

        return $query->fetchAll();
    }
}

