<?php

namespace Fiscal\Logic\NotaFiscalEletronica\CartaCorrecao;


use Indeterminado\Entities\Cartacornfe;
use Setforms2\Shared\Registry;
use Indeterminado\Entities\Arqxmlnfe;

class CartaCorrecaoNfe {

    public static function insereCarta($nrorg, $cdfilial, $nrlanctonf, $nrseq, $descricao,
                                       $status, $motivo, $dthrprotocolo,$protocolo, $numlote, $emprelote,
                                       $idemailcce = 'P', $idemailccetrans = 'N' ){
        /** @var $cartacorr Cartacornfe */
        $cartacorr = new Cartacornfe();
        $cartacorr->setNrorg($nrorg);
        $cartacorr->setCdemplotecce($emprelote);
        $cartacorr->setCdfilial($cdfilial);
        $cartacorr->setNrlanctonf($nrlanctonf);
        $cartacorr->setNrseqcce($nrseq);
        $cartacorr->setDscorrecaonfe($descricao);
        $cartacorr->setCdstatuscce($status);
        $cartacorr->setDsobsstatuscce($motivo);
        $cartacorr->setDthrprotocolcce($dthrprotocolo);
        $cartacorr->setNrprotocolcce($protocolo);
        $cartacorr->setNrlotecce($numlote);
        $cartacorr->setIdemailcce($idemailcce);
        $cartacorr->setIdemailccetrans($idemailccetrans);
        $cartacorr->persist();
        Registry::getEntityManager()->flush();
    }


    private function salvaArqXml($xml, $cdfilial, $nrlanctonf, $idtipoarqxml, $nrorg){

        try {
            $xml = (string)str_replace('<?xml version="1.0" encoding="UTF-8"?>', ' ', $xml);
            $xml = str_replace("\n", '', $xml);
            /** @var $arqxml Arqxmlnfe */
            $arqxml = Arqxmlnfe::findOneByNrorgAndCdfilialAndNrlanctonfAndIdtipoarqxml($nrorg,
                $cdfilial,
                $nrlanctonf,
                $idtipoarqxml
            );

            if ($arqxml) {
                $arqxml->setDsarqxmlnfe(substr($xml, 0, 2001));


            } else {
                $arqxml = new Arqxmlnfe();
                $arqxml->setNrorg($nrorg);
                $arqxml->setCdfilial($cdfilial);
                $arqxml->setNrlanctonf($nrlanctonf);
                $arqxml->setIdtipoarqxml($idtipoarqxml);
                $arqxml->setDsarqxmlnfe($xml);
            }
            $arqxml->persist();
            Registry::getEntityManager()->flush();
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public static function updateCartaCorrEmailEnv($nrorg, $cdfilial, $nrlanctonf, $nrseq){

        /** @var $cartacorr Cartacornfe*/
        $cartacorr = Cartacornfe::findOneByCdfilialAndNrlanctonfAndNrseqcceAndNrorg($cdfilial,$nrlanctonf, $nrseq,$nrorg);
        $cartacorr->setIdemailcce(Cartacornfe::IDEMAILCCE_ENVIADO);
        $cartacorr->persist();
        Registry::getEntityManager()->flush();
    }

    public static function updateCartaCorrEmailEnvTransp($nrorg, $cdfilial, $nrlanctonf, $nrseq){

        /** @var $cartacorr Cartacornfe*/
        $cartacorr = Cartacornfe::findOneByCdfilialAndNrlanctonfAndNrseqcceAndNrorg($cdfilial,$nrlanctonf, $nrseq,$nrorg);
        $cartacorr->setIdemailccetrans(Cartacornfe::IDEMAILCCETRANS_ENVIADO);
        $cartacorr->persist();
        Registry::getEntityManager()->flush();
    }




}