<?php
/**
 * Planejamento\Repositories
 * @category Php
 * @package  Planejamento\Repositories
 * @author   matthaeuscarvalho <matthaeus.carvalho@teknisa.com>
 * @license  www.teknisa.com Teknisa
 * @link     http://localhost:9090/tecfood
 */
namespace Planejamento\Repositories;

/**
 * Class Tipoprat
 * @category Php
 * @package  Planejamento\Repositories
 * @author   matthaeuscarvalho <matthaeus.carvalho@teknisa.com>
 * @license  www.teknisa.com Teknisa
 * @link     http://localhost:9090/tecfood
 */
class Tipoprat extends \Doctrine\ORM\EntityRepository
{
    /**
     * Retorna o próximo código do tipo do prato cadastrado
     *
     * @param String $nrorg Organização
     *
     * @throws \Exception|Exception
     * @return array
     */
    public static function retornaMaxCdtipoprat($nrorg)
    {
        try {
            //pesquisa apenas os código numéricos de tipo de prato
            $sql = "select MAX(CDTIPOPRAT) FROM TIPOPRAT
                    WHERE NRORG = $nrorg
                    AND LENGTH(TRIM(TRANSLATE(CDTIPOPRAT, ' +-.0123456789', ' '))) IS NULL";

            $conn = \Setforms2\Shared\Connection::getInstance();
            $result = $conn->fetchAll($sql);
            return $result[0]['MAX(CDTIPOPRAT)'];
        } catch (\Exception $e) {
            throw $e;
        }
    }


    public function retornaCustoPadrao($cdservico, $data, $cdfilial){
        $sql = "SELECT
                   'F' AS TPCONS,
                   P.CDTPRCONSFIX,
                   T.NMTIPOPRAT,
                   DECODE(C.VRCUSTPADRTP, NULL, '0.0000', C.VRCUSTPADRTP)
                FROM
                   TIPOPRAT T,
                   PARAMPLANEJA P
                LEFT JOIN
                   CUSTPADRTP C ON ('$cdservico'   = C.CDSERVFILI   AND
                                    '$data'        = C.DTREFCUSPADR AND
                                    P.CDFILIAL     = C.CDFILIAL     AND
                                    P.CDTPRCONSFIX = C.CDTIPOPRAT)
                WHERE
                   P.CDFILIAL     = '$cdfilial'  AND
                   P.CDTPRCONSFIX = T.CDTIPOPRAT


                UNION ALL

                SELECT
                   'P' AS TPCONS,
                   P.CDTPRCONSPER,
                   T.NMTIPOPRAT,
                   DECODE(C.VRCUSTPADRTP, NULL, '0.0000', C.VRCUSTPADRTP)
                FROM
                   TIPOPRAT T,
                   PARAMPLANEJA P
                LEFT JOIN
                   CUSTPADRTP C ON ('$cdservico'   = C.CDSERVFILI   AND
                                    '$data'        = C.DTREFCUSPADR AND
                                    P.CDFILIAL     = C.CDFILIAL     AND
                                    P.CDTPRCONSPER = C.CDTIPOPRAT)
                WHERE
                   P.CDFILIAL     = '$cdfilial'  AND
                   P.CDTPRCONSPER = T.CDTIPOPRAT";

        $conn = \Setforms2\Shared\Connection::getInstance();
        $result = $conn->fetchAll($sql);
        return $result;
    }
}