DECLARE   @V_CDSEQUENCIAL VARCHAR(20);
BEGIN
    /*REGISTRANDO A PROCEDURE PARA O AGENDADOR DE EVENTOS*/
    SELECT @V_CDSEQUENCIAL = COUNT(*)
    FROM   EVENTOAEV 
    WHERE  NMOBJBDEVEN = 'ETL_FATUINVOICE';
    
    IF @V_CDSEQUENCIAL = 0 BEGIN --> S ADICIONA A PROCEDURE SE ELA NO EXISTIR AINDA NO CADASTRO
            BEGIN TRAN;

            SELECT @V_CDSEQUENCIAL = RIGHT(REPLICATE('0', 10) + ISNULL(MAX(CDEVENTOAEV)+1,0), 10)
            FROM   EVENTOAEV;
        
            INSERT INTO EVENTOAEV 
            (CDEVENTOAEV, NMEVENTOAEV, IDTPEVENAEV, CDOPERINCL, DTINCLEVEN, NMOBJBDEVEN)
            VALUES
            (@V_CDSEQUENCIAL,'ETL Faturamento Comissaria','STP',NULL,GETDATE(),'ETL_FATUINVOICE');
            
            INSERT INTO PARAMEVENTO
            (CDEVENTOAEV,NMPARAMEVEN,IDDADPARAMEVEN,IDTIPPARAMEVEN,DSPARAMEVEN,IDPARAMNULL,VRTAMPARAM,NRSEQPARAMEVEN) 
            VALUES
            (@V_CDSEQUENCIAL,'P_DTINI','D','E','Data Inicial','N',0,'01');
            
            INSERT INTO PARAMEVENTO
            (CDEVENTOAEV,NMPARAMEVEN,IDDADPARAMEVEN,IDTIPPARAMEVEN,DSPARAMEVEN,IDPARAMNULL,VRTAMPARAM,NRSEQPARAMEVEN) 
            VALUES
            (@V_CDSEQUENCIAL,'P_DTFINA','D','E','Data Final','N',0,'02');
        
            COMMIT TRAN;
        IF @@ERROR <> 0 BEGIN
            ROLLBACK TRAN;
            PRINT 'CRIAO DE EVENTOS AGENDVEIS FALHOU';
        END;
    END;
END;
GO

/*Cadastrando os fatos e dimenses para o DW*/
BEGIN
   EXEC CRIA_FATOS 'ETLFATUINVOICE', 'VRFATUETLFAC',   'Faturamento Comissaria', 'Comissaria' ;
   EXEC CRIA_FATOS 'ETLFATUINVOICE', 'VRMERCETLFAC',   'Valor de Mercadoria',    'Comissaria' ;
   EXEC CRIA_FATOS 'ETLFATUINVOICE', 'VRSERVETLFAC',   'Valor do Servio',       'Comissaria' ;
   EXEC CRIA_FATOS 'ETLFATUINVOICE', 'VRTXARETLFAC',   'Taxa do Aeroporto',      'Comissaria' ;
   EXEC CRIA_FATOS 'ETLFATUINVOICE', 'VRDESCETLFAC',   'Desconto',               'Comissaria' ;
   EXEC CRIA_FATOS 'ETLFATUINVOICE', 'VRACREETLFAC',   'Acrscimo',              'Comissaria' ;
   EXEC CRIA_FATOS 'ETLFATUINVOICE', 'VRIMPOETLFAC',   'Impostos',               'Comissaria' ;   

   EXEC CRIA_DIME 'ETLFATUINVOICE',  'CDFILIAL',   'Filial',   'FILIAL',   'CDFILIAL',   'NMFILIAL',   NULL ; 
   EXEC CRIA_DIME 'ETLFATUINVOICE',  'CDEMPRESA',  'Empresa',  'EMPRESA',  'CDEMPRESA',  'NMEMPRESA',  NULL ; 
   EXEC CRIA_DIME 'ETLFATUINVOICE',  'CDPAIS',     'Pas',     'PAIS',     'CDPAIS',     'NMPAIS',     NULL ; 
   EXEC CRIA_DIME 'ETLFATUINVOICE',  'CDAREAGERE', 'Regional', 'AREAGERE', 'CDAREAGERE', 'NMAREAGERE', NULL ;    
   EXEC CRIA_DIME 'ETLFATUINVOICE',  'CDCLIENTE',  'Cliente',  'CLIENTE',  'CDCLIENTE',  'NMFANTCLIE', NULL ;    
   EXEC CRIA_DIME 'ETLFATUINVOICE',  'ANETLFAC',   'Ano',      NULL,       NULL,         NULL,         NULL ;    
   EXEC CRIA_DIME 'ETLFATUINVOICE',  'MEETLFAC',   'Ms',      NULL,       NULL,         NULL,         NULL ;    
END;
GO